#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "SpiceUsr.h"

#define  STRLEN 100

//getfov_c
#define  BCVLEN 5       //max number of FOV bound vectors
#define  ROOM    10


main(int argc, char *argv[]) {


  SpiceDouble             lat;
  SpiceDouble             lon;
  SpiceDouble             radius;
  
  SpiceDouble             phase, incidence, emission;
  
  SpiceDouble             xpoint[3];
  SpiceDouble             xsrfvec[3];
  SpiceDouble             subpoint[3];
  SpiceDouble             subsrfvec[3];

  SpiceDouble             et;
  SpiceDouble             start_et;
  SpiceDouble             trgepc;
  SpiceChar               utc[STRLEN];
  SpiceChar               trgutc[STRLEN];
  
  SpiceDouble             SC_pos_bd[3];
  SpiceDouble             lt_SC, lt_lunar;

  
  //getfov_c releted variables
  SpiceChar        shape  [STRLEN];
  SpiceChar        frame  [STRLEN]; //name of frame that FOV/boresight are defined.
  SpiceDouble      bsight [3]; //boresight vector
  SpiceInt         n_bcv; //number of FOV bound vectors
  SpiceDouble      bounds [BCVLEN][3];
  SpiceBoolean     found;
  
  //ϻ֤
  SpiceChar   time[STRLEN]="2004-05-17T09:30:00";
  
  //instrument NAIF ID
  //AMICA: -130102  SpiceInt         instid = -130102;
  //NIRS: -130200   SpiceInt         instid = -130200;
  SpiceInt         instid = -130102;
  
  if (argc < 2) {
    fprintf(stderr, "Usage: %s kernel ...\n",argv[0]);
    exit(-1);
  }
  
  
  //Ѥkernelɤ߹ߡti2utcȤή㤦ɤǤ褤
  while (argc > 1) {
    furnsh_c (argv[1]);
    fprintf(stderr,"%s is loaded.\n",argv[1]);
    --argc;
    ++argv;
  }
  
  //¬λ٥ȥ
  getfov_c ( instid, BCVLEN, STRLEN, STRLEN,
          shape, frame,  bsight, &n_bcv, bounds );
  
  //¬̾ΡʼºݤˤϺɸ̾Ρˤɽ
  fprintf(stderr, "%s\n",frame);
  
  //ŪˤETѤΤǡUTCγϻ֤ETѴ
  str2et_c ( time, &start_et );
  
  
  //ͭʻ󤬤ʤƤ⥨顼Ȥʤ
  erract_c ("SET",STRLEN,"IGNORE");
  
  //ϻ֤2ʬ10ù
  for(et=start_et;et< start_et+3600*2;et=et+10){
    
    //߻
    et2utc_c ( et, "ISOC", 0, STRLEN, utc );
    printf("%s\t",utc);
    
    //̾õľ
    subpnt_c ( "Intercept: ellipsoid" ,
            "MOON",  et,     "IAU_MOON", "LT+S",
            "MUSES-C", subpoint, &trgepc, subsrfvec );
    
    //ľ֤а٤Ѵ
    reclat_c ( subpoint, &radius, &lon, &lat );
    lon *= dpr_c();
    if (lon < 0) {
      lon = 180 - lon;
    }
    lat *= dpr_c();
    printf ("%4.2f\t%4.2f\t", lat, lon);
    
    //¬λ٥ȥη̾Ǥfootprint֤
    sincpt_c ( "Ellipsoid", "MOON", et, "IAU_MOON", "LT+S", 
            "MUSES-C",  frame,   bsight,   xpoint, 
            &trgepc, xsrfvec, &found );
    
    //ĤʤȤ⤢롥Ĥäʲν
    if(found) {
      //trgepcUTCѴɽ
      et2utc_c ( trgepc, "ISOC", 0, STRLEN, trgutc );
      printf("%s\t",trgutc);
      
      //footprint֤а٤Ѵ
      reclat_c ( xpoint, &radius, &lon, &lat );
      lon *= dpr_c();
      if (lon < 0) {
        lon = 180 - lon;
      }
      lat *= dpr_c();
      printf ("%4.2f\t%4.2f\t", lat, lon);
      
      //footprint֤ˤȾᡤ
      ilumin_c ( "Ellipsoid",
              "MOON", et, "IAU_MOON", "LT+S",
              "MUSES-C",  xpoint,  &trgepc, xsrfvec,
              &phase, &incidence, &emission);
      phase *= dpr_c();
      incidence *= dpr_c();
      emission *= dpr_c();
      printf ("%4.2f\t%4.2f\t%4.2f", phase, incidence, emission);
      
    }
  printf ("\n");
  }
}
